with Text_IO;                use Text_IO;
with Package_1;              use Package_1;
with Package_2;              use Package_2;
with Mathematics;            use  Mathematics;
 
procedure Main_1 is
begin
  Put_Line ("*** Main_1 begins ...");
  New_Line;
 
  Put_Line ("*** Call of subprogram from Package_1:");
  Proc_1 (10);
 
  Put_Line ("*** Call of subprogram from Package_1:");
  Proc_1 (20);
 
  Put_Line ("*** Call of subprogram from Package_2:");
  Proc_2 (Pi);
 
  Put_Line ("*** Call of subprogram from Package_2:");
  Proc_2 (1.0);
 
  Put_Line ("*** Main_1 ends");
end;
package Package_1 is
  procedure Proc_1 (X:Integer);
end Package_1;
with Text_IO;                 use  Text_IO;
package body Package_1 is
  --
  package Integer_IO is new Text_IO.Integer_IO (Integer);
  use Integer_IO;
  --
  procedure Proc_1 (X:Integer) is separate;
end Package_1;
separate (Package_1)
procedure Proc_1 (X:Integer) is
  function Factorial (I:Integer) return Integer is separate;
begin
  Put ("Factorial (");  Put (X);  Put (")");
  Put (" = ");
  Put (Factorial (X));
  New_Line;
 
  New_Line;
end;
separate (Package_1.Proc_1)
function Factorial (I:Integer) return Integer is
  F: Integer;
begin
  if   I < 2  then return I; end if;
 
  F := Factorial (I-1);
  if   F > 0  then  return I * F; end if;
 
  Put ("Factorial ("); Put (I); Put ("): ");
  Put ("Erorr in Factorial ("); Put (I-1); Put (")");
  New_Line;
  return 0;
 
exception
  when others =>
    New_Line;
    Put ("Factorial ("); Put (I); Put ("): !!! Exception !!! ");  New_Line;
    return 0;
end;
package Package_2 is
  procedure Proc_2 (X:Float);
end Package_2;
with Text_IO;                  use Text_IO;
 
package body Package_2 is
  --
  package Float_IO is new Text_IO.Float_IO (Float);
  use Float_IO;
  --
  procedure Proc_2 (X:Float) is separate;
end Package_2;
with Mathematics;                  use  Mathematics;
separate (Package_2)
procedure Proc_2 (X:Float) is
begin
  Put ("Sin (");  Put (X);  Put (")");
  Put (" = ");
  Put (Sin (X));
  New_Line;
 
  Put ("Exp (");  Put (X);  Put (")");
  Put (" = ");
  Put (Exp (X));
  New_Line;
 
  New_Line;
end;
